#include "Chunk.h"

Chunk::Chunk(void)  :   m_pChunk( 0 ), m_channel( 0 )
{
}

Chunk::~Chunk(void)
{
    Free();
}

bool Chunk::Load( const std::string & musicFileName )
{
    m_pChunk = Mix_LoadWAV( musicFileName.c_str() );
    return m_pChunk != 0;
}

void Chunk::Free()
{
    if( IsLoaded() ) {
        Mix_FreeChunk( m_pChunk );
        m_pChunk = 0;
    }
}

bool Chunk::Play( const bool loop /* = false */ )
{
    if( IsLoaded() )
        m_channel = Mix_PlayChannel( -1, m_pChunk, (loop ? -1 : 0) );

    return m_channel != -1;
}

void Chunk::Halt()
{
    if( IsLoaded() ) {
        Mix_HaltChannel( m_channel );
    }
}
