#include "Music.h"

Music::Music(void)  : m_pMusic( 0 )
{
}

Music::~Music(void)
{
    Free();
}

bool    Music::Load( const std::string & musicFileName )
{
    if( IsLoaded() )
        Free();

    m_pMusic = Mix_LoadMUS( musicFileName.c_str() );

    return m_pMusic != 0;
}

void    Music::Free()
{
    if( IsLoaded() ) {
        Mix_FreeMusic( m_pMusic );
        m_pMusic = 0;
    }
}

bool    Music::Play( const bool loop /* = false */ )
{
    bool    ret = false;
    if( IsLoaded() ) {
        ret = Mix_PlayMusic( m_pMusic, (loop ? -1 : 1) ) == 0;
        m_Position.Start();
    }
    return ret;
}

void    Music::Resume()    {
    Mix_ResumeMusic();
    m_Position.Unpause();
}

void    Music::Pause()     {
    Mix_PauseMusic();
    m_Position.Pause();
}

void Music::Halt()
{
    Mix_HaltMusic();
    m_Position.Stop();
}
