#ifndef _MUSIC_H
#define _MUSIC_H

#include "Sound.h"
#include "Timer.h"
#include <SDL/SDL_mixer.h>

class Music :   public Sound
{
public:
    Music(void);
    ~Music(void);
    
    bool    Load( const std::string & musicFileName );
    void    Free();

    bool    IsLoaded() const    {   return m_pMusic != 0;   }
    bool    IsPlaying() {   return Mix_PlayingMusic() != 0; }
    bool    IsPaused()  {   return Mix_PausedMusic() != 0;  }

    bool    Play( const bool loop = false );
    void    Resume();
    void    Pause();
    void    Halt();

    Uint32  GetCurrentPosition()    {   return m_Position.GetTicks();   }

private:
    Mix_Music * m_pMusic;
    Timer       m_Position;
};

#endif // _MUSIC_H
